"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TeaDrawer = void 0;
var tslib_1 = require("tslib");
var React = (0, tslib_1.__importStar)(require("react"));
var prop_types_1 = (0, tslib_1.__importDefault)(require("prop-types"));
var tea_component_1 = require("tea-component");
var TeaDrawer = function (_a) {
    var size = _a.size, title = _a.title, style = _a.style, events = _a.events, visible = _a.visible, subtitle = _a.subtitle, showMask = _a.showMask, className = _a.className, placement = _a.placement, extraSlot = _a.extraSlot, footerSlot = _a.footerSlot, childrenSlot = _a.childrenSlot, disableCloseIcon = _a.disableCloseIcon, outerClickClosable = _a.outerClickClosable;
    var eventsList = {
        onClose: function () { return (events === null || events === void 0 ? void 0 : events.onClose) && events.onClose({}); },
        onExited: function () { return (events === null || events === void 0 ? void 0 : events.onExited) && events.onExited({}); },
    };
    return (React.createElement(tea_component_1.Drawer, (0, tslib_1.__assign)({ size: size, title: title, style: style, visible: visible, extra: extraSlot, footer: footerSlot, subtitle: subtitle, showMask: showMask, className: className, placement: placement, disableCloseIcon: disableCloseIcon, outerClickClosable: outerClickClosable }, eventsList), childrenSlot));
};
exports.TeaDrawer = TeaDrawer;
TeaDrawer.propTypes = {
    style: prop_types_1.default.object,
    visible: prop_types_1.default.bool,
    title: prop_types_1.default.string,
    showMask: prop_types_1.default.bool,
    extraSlot: prop_types_1.default.node,
    subtitle: prop_types_1.default.string,
    footerSlot: prop_types_1.default.node,
    className: prop_types_1.default.string,
    childrenSlot: prop_types_1.default.node,
    disableCloseIcon: prop_types_1.default.bool,
    size: prop_types_1.default.oneOf(['m', 'l']),
    outerClickClosable: prop_types_1.default.bool,
    events: prop_types_1.default.objectOf(prop_types_1.default.func),
    placement: prop_types_1.default.oneOf(['right', 'left']),
};
exports.default = TeaDrawer;
//# sourceMappingURL=index.js.map